#
# This is the SPEC file for creating binary and source RPMs for the Dom0.
#
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#

Name:		qubes-gui-daemon
Version:	4.1.1
Release:	1%{dist}
Summary:	The Qubes GUI virtualization (Dom0 side) 

Group:		Qubes
Vendor:		Invisible Things Lab
License:	GPL
URL:		http://www.qubes-os.org

Requires:	xorg-x11-server-Xorg pulseaudio-libs
Requires:	service(graphical-login)
Requires:	pulseaudio
Requires:	libconfig
Requires:	qubes-libvchan-xen
Requires:   python%{python3_pkgversion}-xcffib
Requires:   qubes-utils >= 3.1.0
Requires:   python%{python3_pkgversion}-pydbus

BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:	pulseaudio-libs-devel
BuildRequires:	libXt-devel
BuildRequires:	libXext-devel
BuildRequires:	libXrandr-devel
BuildRequires:	libconfig-devel
BuildRequires:	libpng-devel
BuildRequires:	libnotify-devel
BuildRequires:	xen-devel
BuildRequires:	dbus-glib-devel
BuildRequires:	help2man
BuildRequires:	gcc
BuildRequires:	qubes-core-libs-devel >= 1.6.1
BuildRequires:	qubes-core-libs
BuildRequires:	qubes-gui-common-devel >= 3.2.0
BuildRequires:	qubes-libvchan-xen-devel

Source0: %{name}-%{version}.tar.gz

%description
The Qubes GUI virtualization infrastructure that needs to be installed in Dom0.

%package -n qubes-gui-dom0
Summary:    Dom0 part of Qubes GUI
# For now require also gui-daemon in dom0, when dropping GUI in dom0, this
# dependency should be dropped
Requires:   qubes-gui-daemon
Requires:	qubes-core-dom0 >= 1.3.14
Requires:   python%{python3_pkgversion}-setuptools


%description -n qubes-gui-dom0
Dom0 files for Qubes GUI virtualization. This include core-admin extension,
policy files etc.

%prep
%setup -q

%build
make clean
make all BACKEND_VMM=xen

%py3_build

%pre

%install
rm -rf $RPM_BUILD_ROOT
%make_install
%py3_install

%triggerin -- xorg-x11-server-Xorg
ln -sf /usr/bin/X-wrapper-qubes /usr/bin/X

%postun
if [ "$1" = 0 ] ; then
	# no more packages left
    ln -sf /usr/bin/Xorg /usr/bin/X
fi

%clean
rm -rf $RPM_BUILD_ROOT
rm -f %{name}-%{version}

%files
%defattr(-,root,root,-)
%attr(4750,root,qubes) /usr/bin/qubes-guid
%{_mandir}/man1/qubes-guid.1.gz
/usr/bin/pacat-simple-vchan
/usr/bin/X-wrapper-qubes
%{_libdir}/qubes-gui-daemon/shmoverride.so
%config(noreplace) %{_sysconfdir}/qubes/guid.conf
/etc/xdg/autostart/qubes-screen-layout-watches.desktop
/etc/X11/xinit/xinitrc.d/qubes-localgroup.sh
/usr/share/dbus-1/interfaces/org.qubesos.Audio.xml
%config(noreplace) /etc/dbus-1/system.d/org.qubesos.Audio.conf
/usr/libexec/qubes/watch-screen-layout-changes
/usr/lib/qubes/icon-receiver
%config %{_sysconfdir}/qubes-rpc/qubes.WindowIconUpdater

%files -n qubes-gui-dom0
%config(noreplace) %{_sysconfdir}/qubes-rpc/policy/qubes.ClipboardPaste
%config(noreplace) %{_sysconfdir}/qubes-rpc/policy/qubes.WindowIconUpdater
%{python3_sitelib}/qubesguidaemon-*.egg-info
%{python3_sitelib}/qubesguidaemon

%changelog
* Fri Mar 29 2019 Qubes OS Team <qubes-devel@groups.google.com>
- For complete changelog see: https://github.com/QubesOS/qubes-gui-daemon

* Fri Mar 29 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 4ef6690
- version 4.1.1

* Sat Mar 09 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 05afcca
- rpm: use %{python3_pkgversion} to make it CentOS compatible

* Fri Mar 08 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f6b25d6
- xside: send old MSG_CLIPBOARD_DATA if agent is old

* Fri Mar 08 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 8f57fd3
- Merge remote-tracking branch 'origin/pr/15' into clipboard-msg

* Fri Mar 08 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 99d6488
- xside: save agent protocol version

* Sat Mar 02 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a029825
- version 4.1.0

* Sat Mar 02 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5257cc7
- travis: add VM packaging tests

* Sat Mar 02 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ceb4ebd
- debian: initial Debian packaging

* Sat Mar 02 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 82088aa
- Move shmoverride.so to subdirectory

* Sat Mar 02 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 878258e
- Fix shmoverride link flags

* Sat Mar 02 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b31fbed
- Fix file permissions - drop executable bit where not needed

* Sat Mar 02 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 8130273
- Fix a bunch of compiler warnings

* Sat Mar 02 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e64bac0
- makefile: remove obsolete rpm building rules

* Sat Mar 02 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 4c795fc
- rpm: move installation commands to Makefile

* Sat Mar 02 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c66b0f7
- rpm: split out qubes-gui-daemon built for both dom0 and VM

* Sat Mar 02 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b7538eb
- travis: drop R4.0

* Fri Feb 08 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d2533c3
- Handle XShmAttach errors reported asynchronously (grant refs version)

* Fri Feb 08 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - da147e2
- Handle XShmAttach errors reported asynchronously

* Fri Feb 08 2019 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 9589da3
- Merge remote-tracking branch 'origin/pr/21' into grant-refs

* Mon Nov 26 2018 Frédéric Pierret (fepitre) <frederic.epitre@orange.fr> - f0224f7
- tracis-ci: add support for fc29 dom0

* Mon Nov 26 2018 Frédéric Pierret <frederic.epitre@orange.fr> - 7edd6c9
- Make gcc ignore deprecated function

* Mon Nov 26 2018 Frédéric Pierret <frederic.epitre@orange.fr> - 5f14ea6
- Fix GCC8 error

* Sat Sep 29 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 67afa8b
- rpm: fix building with mock

* Sat Sep 15 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 1f55c60
- version 4.0.9

* Sat Sep 15 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a90544a
- xside: avoid making X11 calls in signal handler

* Thu Sep 13 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - af14f3e
- Clarify error message on mic attach if audio not enabled in the VM

* Fri Jul 27 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 840c849
- Merge remote-tracking branch 'qubesos/pr/23'

* Fri Jul 27 2018 Jean-Philippe Ouellet <jpo@vt.edu> - 148fb42
- Correct note about "temporary" shm lifecycle

* Tue May 15 2018 Simon Gaiser <simon@invisiblethingslab.com> - 3b9e58f
- Support new GUI protocol version with flexible MSG_WINDOW_DUMP

* Tue May 08 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6f5587b
- version 4.0.8

* Tue May 08 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 325a784
- gui-daemon: fix potential int overflow

* Sat Apr 21 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 2057273
- gui-daemon: fix forcing colorful frame when vm_window->image == NULL

* Tue Apr 03 2018 Frédéric Pierret <frederic.epitre@orange.fr> - 8eb0ae9
- spec.in: add changelog placeholder

* Sun Apr 01 2018 Frédéric Pierret <frederic.epitre@orange.fr> - 8d09634
- Create .spec.in and Source0

* Sun Mar 04 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5340e17
- version 4.0.7

* Sun Mar 04 2018 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 72c8cda
- icon-receiver: make it more defensive against X11 race conditions

* Fri Dec 29 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7b4c255
- icon-receiver: cache icons received for not (yet) existing windows

* Sat Dec 23 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 35ec463
- version 4.0.6

* Thu Dec 07 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d1e1167
- Merge remote-tracking branch 'qubesos/pr/19'

* Thu Dec 07 2017 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 1d31918
- Merge remote-tracking branch 'qubesos/pr/18'

* Wed Dec 06 2017 Jean-Philippe Ouellet <jpo@vt.edu> - 94fd49d
- Move path to qvm-kill into header

* Wed Dec 06 2017 Jean-Philippe Ouellet <jpo@vt.edu> - 4b0fd06
- Group file paths

* Wed Dec 06 2017 Jean-Philippe Ouellet <jpo@vt.edu> - 0304cd2
- Remove dependency on xl toolstack

* Wed Dec 06 2017 Jean-Philippe Ouellet <jpo@vt.edu> - bf46809
- Actually dispatch resolution change notifications

* Tue Dec 05 2017 Jean-Philippe Ouellet <jpo@vt.edu> - 4f3c468
- Coalesce at least some screen-change events

* Tue Dec 05 2017 Jean-Philippe Ouellet <jpo@vt.edu> - 772997a
- Use cached x11 sock fd value

* Tue Dec 05 2017 Jean-Philippe Ouellet <jpo@vt.edu> - 26f6c3a
- Simplify error handling with err(3) family

* Tue Dec 05 2017 Jean-Philippe Ouellet <jpo@vt.edu> - 15adf34
- Improve usage msg

* Tue Dec 05 2017 Jean-Philippe Ouellet <jpo@vt.edu> - 5c04122
- Sort includes

* Tue Dec 05 2017 Jean-Philippe Ouellet <jpo@vt.edu> - 87a68c8
- Make resource exhaustion not fatal

